-- Business
UPDATE business SET projectNumberingEnabled=FALSE WHERE projectNumberingEnabled IS NULL;
UPDATE business SET taxesEnabled=FALSE WHERE taxesEnabled IS NULL;
UPDATE business SET minimumInterval=0 WHERE minimumInterval IS NULL;

ALTER TABLE business ALTER COLUMN billableTimeExactPrecisionEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN billingEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN enabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN expensesEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN invoiceNumberingEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN invoiceNumberingPerClientEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN productsEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN projectNumberingEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN taxesEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN tripsEnabled BOOLEAN NOT NULL;
ALTER TABLE business ALTER COLUMN roundingInterval INTEGER NOT NULL;
ALTER TABLE business ALTER COLUMN minimumInterval INTEGER NOT NULL;

-- CatalogItem
ALTER TABLE catalogitem ALTER COLUMN enabled BOOLEAN NOT NULL;

-- Client
UPDATE client SET active=TRUE WHERE active IS NULL;
UPDATE client SET taxExempt=FALSE WHERE taxExempt IS NULL;
UPDATE client SET taskBillable=TRUE WHERE taskBillable IS NULL;
UPDATE client SET taskTimeMinimumInterval=0 WHERE taskTimeMinimumInterval IS NULL;

ALTER TABLE client ALTER COLUMN active BOOLEAN NOT NULL;
ALTER TABLE client ALTER COLUMN billable BOOLEAN NOT NULL;
ALTER TABLE client ALTER COLUMN taxExempt BOOLEAN NOT NULL;
ALTER TABLE client ALTER COLUMN taskBillable BOOLEAN NOT NULL;
ALTER TABLE client ALTER COLUMN taskTimeRoundingEnabled BOOLEAN NOT NULL;
ALTER TABLE client ALTER COLUMN taskTimeRoundingInterval INTEGER NOT NULL;
ALTER TABLE client ALTER COLUMN taskTimeMinimumInterval INTEGER NOT NULL;

-- Deposit
ALTER TABLE deposit ALTER COLUMN date TIMESTAMP NOT NULL;

-- Expense
ALTER TABLE expense ALTER COLUMN billable BOOLEAN NOT NULL;
ALTER TABLE expense ALTER COLUMN taxGroupEnabled BOOLEAN NOT NULL;
ALTER TABLE expense ALTER COLUMN date TIMESTAMP NOT NULL;

-- ExpenseCategory
ALTER TABLE expensecategory ALTER COLUMN enabled BOOLEAN NOT NULL;

-- Invoice
UPDATE invoice SET cancelled=FALSE WHERE cancelled IS NULL;
UPDATE invoice SET paid=FALSE WHERE paid IS NULL;

ALTER TABLE invoice ALTER COLUMN cancelled BOOLEAN NOT NULL;
ALTER TABLE invoice ALTER COLUMN paid BOOLEAN NOT NULL;
ALTER TABLE invoice ALTER COLUMN totalDiscountEnabled BOOLEAN NOT NULL;
ALTER TABLE invoice ALTER COLUMN date TIMESTAMP NOT NULL;

-- Item
UPDATE item SET minimumInterval=0 WHERE minimumInterval IS NULL;
UPDATE item SET billableTimeExactPrecisionEnabled=FALSE WHERE billableTimeExactPrecisionEnabled IS NULL;

ALTER TABLE item ALTER COLUMN taxGroupEnabled BOOLEAN NOT NULL;
ALTER TABLE item ALTER COLUMN enabled BOOLEAN NOT NULL;
ALTER TABLE item ALTER COLUMN unitsDiscountEnabled BOOLEAN NOT NULL;
ALTER TABLE item ALTER COLUMN rateDiscountEnabled BOOLEAN NOT NULL;
ALTER TABLE item ALTER COLUMN billableTimeExactPrecisionEnabled BOOLEAN NOT NULL;
ALTER TABLE item ALTER COLUMN roundingInterval INTEGER NOT NULL;
ALTER TABLE item ALTER COLUMN minimumInterval INTEGER NOT NULL;

-- Payment
ALTER TABLE payment ALTER COLUMN date TIMESTAMP NOT NULL;

-- Product
ALTER TABLE product ALTER COLUMN taxGroupEnabled BOOLEAN NOT NULL;
ALTER TABLE product ALTER COLUMN quantityDiscountEnabled BOOLEAN NOT NULL;
ALTER TABLE product ALTER COLUMN priceDiscountEnabled BOOLEAN NOT NULL;
ALTER TABLE product ALTER COLUMN date TIMESTAMP NOT NULL;

-- Project
UPDATE project SET taskBillable=TRUE WHERE taskBillable IS NULL;
UPDATE project SET expenseBillable=TRUE WHERE taskBillable IS NULL;
UPDATE project SET tripBillable=TRUE WHERE taskBillable IS NULL;
UPDATE project SET taskTimeMinimumInterval=0 WHERE taskTimeMinimumInterval IS NULL;

ALTER TABLE project ALTER COLUMN billable BOOLEAN NOT NULL;
ALTER TABLE project ALTER COLUMN taskBillable BOOLEAN NOT NULL;
ALTER TABLE project ALTER COLUMN expenseBillable BOOLEAN NOT NULL;
ALTER TABLE project ALTER COLUMN tripBillable BOOLEAN NOT NULL;
ALTER TABLE project ALTER COLUMN taskTimeRoundingEnabled BOOLEAN NOT NULL;
ALTER TABLE project ALTER COLUMN startDate TIMESTAMP NOT NULL;
ALTER TABLE project ALTER COLUMN taskTimeRoundingInterval INTEGER NOT NULL;
ALTER TABLE project ALTER COLUMN taskTimeMinimumInterval INTEGER NOT NULL;

-- Task
UPDATE task SET completed=FALSE WHERE completed IS NULL;
UPDATE task SET billable=TRUE WHERE billable IS NULL;
UPDATE task SET timeRoundingMinimumInterval=0 WHERE timeRoundingMinimumInterval IS NULL;
UPDATE task SET estimatedTime=0 WHERE estimatedTime IS NULL;

ALTER TABLE task ALTER COLUMN completed BOOLEAN NOT NULL;
ALTER TABLE task ALTER COLUMN billable BOOLEAN NOT NULL;
ALTER TABLE task ALTER COLUMN taxGroupEnabled BOOLEAN NOT NULL;
ALTER TABLE task ALTER COLUMN timeRoundingEnabled BOOLEAN NOT NULL;
ALTER TABLE task ALTER COLUMN priceDiscountEnabled BOOLEAN NOT NULL;
ALTER TABLE task ALTER COLUMN quantityDiscountEnabled BOOLEAN NOT NULL;
ALTER TABLE task ALTER COLUMN startDate TIMESTAMP NOT NULL;
ALTER TABLE task ALTER COLUMN timeRoundingInterval INTEGER NOT NULL;
ALTER TABLE task ALTER COLUMN timeRoundingMinimumInterval INTEGER NOT NULL;
ALTER TABLE task ALTER COLUMN estimatedTime INTEGER NOT NULL;

-- TaskCategory
UPDATE taskcategory SET timeRoundingMinimumInterval=0 WHERE timeRoundingMinimumInterval IS NULL;

ALTER TABLE taskcategory ALTER COLUMN enabled BOOLEAN NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN billable BOOLEAN NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN timeRoundingEnabled BOOLEAN NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN timeRoundingInterval INTEGER NOT NULL;
ALTER TABLE taskcategory ALTER COLUMN timeRoundingMinimumInterval INTEGER NOT NULL;

-- TaxGroup
UPDATE taxgroup SET enabled=TRUE WHERE enabled IS NULL;

ALTER TABLE taxgroup ALTER COLUMN enabled BOOLEAN NOT NULL;

-- TaxRule
ALTER TABLE taxrule ALTER COLUMN additive BOOLEAN NOT NULL;

-- TimeEntry
UPDATE timeentry SET pausedTime=0 WHERE pausedTime IS NULL;

-- Reset the pause for time entries if it's larger than max int (2^31-1) and add a #longpause tag to them
UPDATE timeentry SET tags=concat(tags, concat(',#longpause-', pausedTime)) WHERE pausedTime>2147483647;
UPDATE timeentry SET pausedTime=0 WHERE pausedTime>2147483647;

ALTER TABLE timeentry ALTER COLUMN billable BOOLEAN NOT NULL;
ALTER TABLE timeentry ALTER COLUMN date TIMESTAMP NOT NULL;
ALTER TABLE timeentry ALTER COLUMN elapsedTime INTEGER NOT NULL;
ALTER TABLE timeentry ALTER COLUMN pausedTime INTEGER NOT NULL;
ALTER TABLE timeentry ALTER COLUMN explicitBillableTime INTEGER;

-- Trip
ALTER TABLE trip ALTER COLUMN billable BOOLEAN NOT NULL;

-- TripRate
ALTER TABLE triprate ALTER COLUMN enabled BOOLEAN NOT NULL;